<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class User extends MX_Controller {

    const TOKENPW = 'violet';

    public function __construct() {
        parent::__construct();
        $this->load->helper('cookie');
    }

    public function profile() {
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $this->load->model('user_model');
            $this->load->model('servicepackage_model');
            $user = $user_info['user'];
            $us_id = $user_info['us_id'];
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $data = $this->get_data($src, $token, $us_id);
            $u = $this->user_model->get_user_by_id($us_id);
            $data['current_tab'] = $this->uri->segment(4, 'edit-basic');
            $data['packages'] = $this->servicepackage_model->getAllPackages();
            $data['is_viettel'] = $user_info['is_viettel'];
            
            $data = array_merge($data, $u);
            $data = array_merge($data, $user_info);
			
            $this->load->view('frontend/user_profile', $data);
        } else {
            redirect('frontend/home');
        }
    }

    public function packageRegister() {
        $result = array();
        $input = $this->input->post();
        $this->load->model('user_model');
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            parse_str($user_info['user'], $info);
            $this->load->model('servicepackage_model');

            $package = $this->servicepackage_model->getPackage($input['p_id']);
            $user = $user_info['user'];
            $us_id = $user_info['us_id'];
            $user = $this->user_model->get_user_by_id($us_id);
            $result['can_buy'] = 1;
            $result['can_edit'] = 0;
            if ($user['acc_balanced'] < $package['p_price']) {
                $result['can_buy'] = 0;
            }
            
            if ($user['p_id'] < 1) {
                $result['can_edit'] = 1;
            }
            if ($info['fullname']=="")
            {
                $result['can_edit'] = 1;
            }
            $result['info'] = $info;
            $result['user'] = $user;
            $result['package'] = $package;
            $result['modal'] = $this->load->view('frontend/package_register_modal', $result, true);
        } else {
            
        }
        echo json_encode($result);
    }

    public function finishRegisterPackage() {
        $result = array();
        $result['success'] = 0;
        $this->load->model('user_model');
        $input = $this->input->post();
        $user_info = $this->session->userdata('userInfo');
        parse_str($user_info['user'], $info);
        if (isset($input['fullname'])) {
            if (strlen($input['fullname']) < 1) {
                $result['errors'][] = "Vui lòng nhập họ tên đầy đủ tiếng Việt";
            }
            if (strlen($input['school']) < 1) {
                $result['errors'][] = "Vui lòng nhập đơn vị công tác";
            }
            if (!isset($result['errors'])) {
                $user_info = $this->session->userdata('userInfo');
                if ($user_info) {

                    $src = "SBG";
                    $us_id = $user_info['us_id'];
                    $input['password'] = '';
                    $input['oldpass'] = '';
                    $input['gender'] = '';
                    $input['email'] = '';
                    $input['province'] = '';
                    $info['fullname'] = $input['fullname'];
                    $info['school'] = $input['school'];
                    $token = md5($us_id . self::TOKENPW);
                    $user = $this->get_data($src, $token, $us_id);
                    if ($input) {
                        $this->load->model('user_model');
                        $update = $this->user_model->update_user($src, $token, $input, $us_id);
                        $info = urldecode(http_build_query($info));
                        $userdata = array('username' => $user_info['username'], 'user' => $info, 'us_id' => $user_info['us_id'], 'logined_in' => TRUE, 'is_viettel' => $user_info['is_viettel']);
                        $this->session->set_userdata('userInfo', $userdata);
                    }
                }
            }
        }
        if (isset($result['errors'])) {
            echo json_encode($result);
            die();
        }
        $this->load->model('servicepackage_model');
        $us_id = $user_info['us_id'];
        $user = $this->user_model->get_user_by_id($us_id);
        $package = $this->servicepackage_model->getPackage($input['p_id']);
        $user['acc_balanced'] = $user['acc_balanced'] - $package['p_price'];
        
        $currentExpireDate = $user['expire_date'] == NULL || trim($user['expire_date']) == '' ? date('Y-m-d 00:00:00') : $user['expire_date'];
        $user['expire_date'] = date('Y-m-d', strtotime("+" . $package['p_period'] . " ".$package['p_unit'], strtotime($currentExpireDate))); 
        $user['p_id'] = $package['p_id'];
        $this->user_model->updateUser($us_id, $user);
        $user['expire_date'] = date("d-m-Y", (strtotime($user['expire_date'])));
        $result['expire_date'] = $user['expire_date'];
        $result['success'] = 1;
        echo json_encode($result);
    }

    public function regpackage() {
        $user_info = $this->session->userdata('userInfo');
        parse_str($user_info['user'], $info);
        $p_id = $this->input->post('p_id', TRUE);

        $us_id = (int) $info['id'];
        $this->load->model('servicepackage_model');
        $this->load->model('user_model');

        $user = $this->user_model->get_user_by_id($us_id);
        $package = $this->servicepackage_model->getPackage($p_id);

        if ($user['acc_balanced'] < $package['p_price']) {
            $message = 'Số tiền trong Tài khoản SBG Online hiện tại của Quí vị là ' . $user['acc_balanced'] . ' đồng.<br /> Để Đăng kí Sử dụng dịch vụ Soạn Bài giảng trực tuyến, Quí vị cần nạp thêm tiền vào tài khoản.';
        } else {
            $user['acc_balanced'] = $user['acc_balanced'] - $package['p_price'];
            $currentExpireDate = $user['expire_date'] == NULL || trim($user['expire_date']) == '' ? date('Y-m-d 00:00:00') : $user['expire_date'];

            $user['expire_date'] = date('Y-m-d', strtotime("+" . $package['p_period'] . " " . $package['p_unit'], strtotime($currentExpireDate)));
            //$user['expire_date'] = date("Y-m-d", (strtotime($user['expire_date']) - 1));

            $user['p_id'] = $package['p_id'];

            $this->user_model->updateUser($us_id, $user);
            $message = 'Quý vị đã đăng kí sử dụng Công cụ Soạn Bài giảng trức tuyến. Quí vị được sử dụng dịch vụ đến hết ngày ' . date('d-m-Y', strtotime($user['expire_date']));
        }

        $this->session->set_flashdata('message', $message);
        redirect('frontend/user/profile#services-register');
    }

    private function get_data($src, $token, $us_id) {
        $this->load->model('user_model');
        $user = $this->user_model->get_user_info($src, $token, $us_id);

        if (strpos($user, '&')) {
            parse_str($user);
            $us = $this->user_model->get_user_by_id($us_id);
            $data = array('us_id' => $us_id, 'username' => $username, 'fullname' => $fullname,
                'gender' => $gender, 'email' => $email, 'phone' => $phone, 'school' => $school, 'province' => $province,
                'acc_balanced' => $us['acc_balanced'], 'expire_date' => $us['expire_date'], 'date_diff' => $this->dateDiff($us['expire_date'])
            );
            return $data;
        } else {
            return "";
        }
    }

    private function dateDiff($expire_date) {
        $date1 = date("Y-m-d");
        if ((strtotime($expire_date) - strtotime($date1)) < 0)
            return "0 ngày còn lại";
        $diff = strtotime($expire_date) - strtotime($date1);
        $years = floor($diff / (365 * 60 * 60 * 24));
        $months = floor(($diff - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
        $days = floor(($diff - $years * 365 * 60 * 60 * 24 - $months * 30 * 60 * 60 * 24) / (60 * 60 * 24));
        if ($years > 0) {
            return $years . " năm, " . $months . " tháng, " . $days . " ngày còn lại";
        } else {
            if ($months > 0) {
                return $months . " tháng, " . $days . " ngày còn lại";
            } else {
                return $days . " ngày còn lại";
            }
        }
    }
    
	public function update_info() {
        $result['success']=0;
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $us_id = $user_info['us_id'];
            $result = array();
            $result['success'] = 0;
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $user = $this->get_data($src, $token, $us_id);
            $input = $this->input->post();
            parse_str($user_info['user'], $info);
            if ($input) {
                if (strlen($input['fullname']) == 0) {
                    $result['errors'][] = array("content"=>"Họ tên không được để trống!","field"=>"fullname");
                }
                if (strlen($input['school']) == 0) {
                    $result['errors'][] = array("content"=>"Tên đơn vị không được để trống!","field"=>"school");
                }

                $input['password'] = '';
                $input['oldpass'] = '';
                $input['province'] = '';
                $this->load->model('user_model');
                if (!isset($result['errors'])) {
                    $result['data'] = $this->user_model->update_user($src, $token, $input, $us_id);
                    $result['success'] = 1;
                    $info['fullname']=$input['fullname'];
                    $info['school']=$input['school'];
                    $info = urldecode(http_build_query($info));
                    $userdata = array('username' => $user_info['username'], 'user' => $info, 'us_id' => $user_info['us_id'], 'logined_in' => TRUE, 'is_viettel' => $user_info['is_viettel']);
                    $this->session->set_userdata('userInfo', $userdata);
                }
                echo json_encode($result);
            }
        } else {
            redirect('frontend/home');
        }
    }
    
    public function update_user() {
        $us_id = $this->uri->segment(4);
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $result = array();
            $result['success'] = 0;
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $user = $this->get_data($src, $token, $us_id);
            $input = $this->input->post();
            if ($input) {
                $input['username'] = $user['username'];
                if (array_key_exists('fullname', $input)) {
                    if (strlen($input['fullname']) == 0) {
                        $result['errors']['fullname_err'] = "Họ tên không được để trống!";
                    }
                } else {
                    $input['fullname'] = $user['fullname'];
                }

                $input['password'] = '';
                $input['oldpass'] = '';
                $this->load->model('user_model');
                if (!isset($result['errors'])) {
                    $result['data'] = $this->user_model->update_user($src, $token, $input, $us_id);
                    $result['success'] = 1;
                }
                echo json_encode($result);
            }
        } else {
            redirect('frontend/home');
        }
    }

    public function change_password() {
        $us_id = $this->uri->segment(4);
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $this->load->model('user_model');
            $us_id = $user_info['us_id'];
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $input = $this->input->post();

            if (strlen($input['passwd']) == 0) {
                $result['errors']['passwd_old_err'] = "Mật khẩu không được để trống!";
            }
			
            if (strlen($input['passwd_new']) == 0) {
                $result['errors']['passwd_new_err'] = "Mật khẩu không được để trống!";
            } else if ($input['passwd'] == $input['passwd_new']) {
                $result['errors']['passwd_new_err'] = "Mật khẩu trùng với mật khẩu hiện tại!";
            }else
			{
				if (!preg_match('/^([0-9a-zA-Z]{6,65})*$/', $input['passwd_new']))
				{
					$result['errors']['passwd_new_err'] = "Mật khẩu ít nhất là 6 kí tự, và chỉ chứa các kí tự số hoặc chữ, <br> không chứa khoảng trắng và không chứa ký tự đặc biệt!";
				}
			}
			
            if ($input['passwd_new'] != $input['confirm_passwd_new']) {
                $result['errors']['confirm_passwd_new_err'] = "Mật khẩu không trùng nhau!";
            }

            if (!isset($result['errors'])) {
                $user = array('username' => $user_info['username'], 'fullname' => null, 'gender' => null, 'email' => null, 'school' => null, 'province' => null, 'password' => $input['passwd_new'], 'oldpass' => $input['passwd']);
                $data = $this->user_model->update_user($src, $token, $user, $us_id);
                parse_str($data);
                switch ($status) {
                    case 0:
                        $result['success'] = 1;
                        break;
                    case 6:
                        $result['errors']['passwd_old_err'] = "Mật khẩu cung cấp không đúng!";
                        break;
                    default:
                        break;
                }
            }

            echo json_encode($result);
        } else {
            redirect('frontend/home');
        }
    }
	
	public function trade_history()
	{
		$this->load->helper('pagging');
		$us_id = $this->uri->segment(4);
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) 
		{
			
			$data['us_id'] = $us_id;
			$data['perpage'] = 10;
			$data['current_page'] = $this->uri->segment(6, 1);
			$data['start'] = ($data['current_page'] - 1) * $data['perpage'];
			$this->load->model('user_model');
			$result = $this->user_model->getPaidlog($data);
			$data['total'] = $this->user_model->countPaiglogs($us_id);
			$data['num_links'] = 2;
			$data['paging_url'] = base_url() . "frontend/user/trade_history/".$us_id."/page/";
			$data['paging'] = pagging($data);
			$paidlogs = array();
			foreach ($result as $paidlog):
				$paidlog['amount'] = number_format($paidlog['amount'], 0);
				$paidlog['paid_time'] = date('d-m-Y H:i:s', strtotime($paidlog['paid_time']));
				array_push($paidlogs, $paidlog);
			endforeach;
			$data['paidlogs'] = $paidlogs;
			echo json_encode($data);
		}else {
            redirect('frontend/home');
        }
	}

}
